import requests
import os
import logging

SCHEDULER_BASE_URL = os.getenv("SCHEDULER_BASE_URL")
BACKEND_BASE_URL = os.getenv("BACKEND_BASE_URL")

logger = logging.getLogger("algoA logger")
missionId = os.getenv("missionId")
planId = os.getenv("planId")


for i in range(10000000):
    print('.', end='')


response = requests.post(SCHEDULER_BASE_URL + '/report', json={
    'missionId': missionId,
    'planId': planId,
    'state': 'DONE',
    'results': None,
})

if response:
    logger.info("???")
    if response.json()['code'] == 'OK':

        response = requests.post(BACKEND_BASE_URL + "/rawDataTrans/", json={
            'missionId': missionId,
            'planId': planId,
            'nodes': [[1, 'S'], [2, 'D'], [3, 'D'], [4, 'I']],
            'edges': [[1, 2], [1, 4], [2, 4], [3, 4]],
        })
        logger.info(f"算法控制程序推送结果完毕 MissionId: {missionId} PlanId: {planId} Message: {response.json()}")
    else:
        logger.error(f"算法控制程序结果反馈未被识别 MissionId: {missionId} PlanId: {planId}")
else:
    logger.error(f"算法控制程序结果反馈失败 MissionId: {missionId} PlanId: {planId}")